Index: extensions/acl_wl/acl_wl.c
===================================================================
--- extensions/acl_wl/acl_wl.c	(revision 1354)
+++ extensions/acl_wl/acl_wl.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/acl_wl.h
===================================================================
--- extensions/acl_wl/acl_wl.h	(revision 1354)
+++ extensions/acl_wl/acl_wl.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_conf.l
===================================================================
--- extensions/acl_wl/aw_conf.l	(revision 1354)
+++ extensions/acl_wl/aw_conf.l	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_conf.y
===================================================================
--- extensions/acl_wl/aw_conf.y	(revision 1354)
+++ extensions/acl_wl/aw_conf.y	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/acl_wl/aw_tree.c
===================================================================
--- extensions/acl_wl/aw_tree.c	(revision 1405)
+++ extensions/acl_wl/aw_tree.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/app_radgw/rgw_clients.c
===================================================================
--- extensions/app_radgw/rgw_clients.c	(revision 1442)
+++ extensions/app_radgw/rgw_clients.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_loglevel/dbg_loglevel_conf.l
===================================================================
--- extensions/dbg_loglevel/dbg_loglevel_conf.l	(revision 1345)
+++ extensions/dbg_loglevel/dbg_loglevel_conf.l	(revision 1554)
@@ -4,5 +4,5 @@
 *													 *
 * Copyright (c) 2019, Thomas Klausner									 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_monitor/dbg_monitor.c
===================================================================
--- extensions/dbg_monitor/dbg_monitor.c	(revision 1405)
+++ extensions/dbg_monitor/dbg_monitor.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_msg_dumps/dbg_msg_dumps.c
===================================================================
--- extensions/dbg_msg_dumps/dbg_msg_dumps.c	(revision 1307)
+++ extensions/dbg_msg_dumps/dbg_msg_dumps.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2016, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dbg_rt/dbg_rt.c
===================================================================
--- extensions/dbg_rt/dbg_rt.c	(revision 1545)
+++ extensions/dbg_rt/dbg_rt.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dict_legacy_xml/dict_lxml_xml.c
===================================================================
--- extensions/dict_legacy_xml/dict_lxml_xml.c	(revision 1318)
+++ extensions/dict_legacy_xml/dict_lxml_xml.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2017, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/dict_nasreq/dict_nasreq.c
===================================================================
--- extensions/dict_nasreq/dict_nasreq.c	(revision 1318)
+++ extensions/dict_nasreq/dict_nasreq.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2017, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rt_default.c
===================================================================
--- extensions/rt_default/rt_default.c	(revision 1336)
+++ extensions/rt_default/rt_default.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rt_default.h
===================================================================
--- extensions/rt_default/rt_default.h	(revision 1336)
+++ extensions/rt_default/rt_default.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rtd_conf.y
===================================================================
--- extensions/rt_default/rtd_conf.y	(revision 1336)
+++ extensions/rt_default/rtd_conf.y	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_default/rtd_rules.c
===================================================================
--- extensions/rt_default/rtd_rules.c	(revision 1336)
+++ extensions/rt_default/rtd_rules.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_deny_by_size/rt_deny_by_size_conf.l
===================================================================
--- extensions/rt_deny_by_size/rt_deny_by_size_conf.l	(revision 1340)
+++ extensions/rt_deny_by_size/rt_deny_by_size_conf.l	(revision 1554)
@@ -4,5 +4,5 @@
 *													 *
 * Copyright (c) 2018, Thomas Klausner									 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_ereg/rtereg.c
===================================================================
--- extensions/rt_ereg/rtereg.c	(revision 1546)
+++ extensions/rt_ereg/rtereg.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_ereg/rtereg.h
===================================================================
--- extensions/rt_ereg/rtereg.h	(revision 1338)
+++ extensions/rt_ereg/rtereg.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2011, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_ereg/rtereg_conf.l
===================================================================
--- extensions/rt_ereg/rtereg_conf.l	(revision 1387)
+++ extensions/rt_ereg/rtereg_conf.l	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/rt_ereg/rtereg_conf.y
===================================================================
--- extensions/rt_ereg/rtereg_conf.y	(revision 1387)
+++ extensions/rt_ereg/rtereg_conf.y	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: extensions/test_app/ta_cli.c
===================================================================
--- extensions/test_app/ta_cli.c	(revision 1305)
+++ extensions/test_app/ta_cli.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2016, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: freeDiameterd/main.c
===================================================================
--- freeDiameterd/main.c	(revision 1450)
+++ freeDiameterd/main.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/extension.h
===================================================================
--- include/freeDiameter/extension.h	(revision 1552)
+++ include/freeDiameter/extension.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/freeDiameter-host.h.in
===================================================================
--- include/freeDiameter/freeDiameter-host.h.in	(revision 1305)
+++ include/freeDiameter/freeDiameter-host.h.in	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2016, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/libfdcore.h
===================================================================
--- include/freeDiameter/libfdcore.h	(revision 1540)
+++ include/freeDiameter/libfdcore.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2016, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: include/freeDiameter/libfdproto.h
===================================================================
--- include/freeDiameter/libfdproto.h	(revision 1423)
+++ include/freeDiameter/libfdproto.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/cnxctx.c
===================================================================
--- libfdcore/cnxctx.c	(revision 1540)
+++ libfdcore/cnxctx.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/cnxctx.h
===================================================================
--- libfdcore/cnxctx.h	(revision 1540)
+++ libfdcore/cnxctx.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/config.c
===================================================================
--- libfdcore/config.c	(revision 1540)
+++ libfdcore/config.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/core.c
===================================================================
--- libfdcore/core.c	(revision 1397)
+++ libfdcore/core.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/dict_base_proto.c
===================================================================
--- libfdcore/dict_base_proto.c	(revision 1439)
+++ libfdcore/dict_base_proto.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdcore-internal.h
===================================================================
--- libfdcore/fdcore-internal.h	(revision 1540)
+++ libfdcore/fdcore-internal.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdd.l
===================================================================
--- libfdcore/fdd.l	(revision 1397)
+++ libfdcore/fdd.l	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/fdd.y
===================================================================
--- libfdcore/fdd.y	(revision 1397)
+++ libfdcore/fdd.y	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/hooks.c
===================================================================
--- libfdcore/hooks.c	(revision 1405)
+++ libfdcore/hooks.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/messages.c
===================================================================
--- libfdcore/messages.c	(revision 1425)
+++ libfdcore/messages.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_ce.c
===================================================================
--- libfdcore/p_ce.c	(revision 1405)
+++ libfdcore/p_ce.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_cnx.c
===================================================================
--- libfdcore/p_cnx.c	(revision 1540)
+++ libfdcore/p_cnx.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_out.c
===================================================================
--- libfdcore/p_out.c	(revision 1305)
+++ libfdcore/p_out.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2016, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/p_psm.c
===================================================================
--- libfdcore/p_psm.c	(revision 1379)
+++ libfdcore/p_psm.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/peers.c
===================================================================
--- libfdcore/peers.c	(revision 1395)
+++ libfdcore/peers.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/queues.c
===================================================================
--- libfdcore/queues.c	(revision 1397)
+++ libfdcore/queues.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/routing_dispatch.c
===================================================================
--- libfdcore/routing_dispatch.c	(revision 1397)
+++ libfdcore/routing_dispatch.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/sctp.c
===================================================================
--- libfdcore/sctp.c	(revision 1544)
+++ libfdcore/sctp.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdcore/sctp3436.c
===================================================================
--- libfdcore/sctp3436.c	(revision 1405)
+++ libfdcore/sctp3436.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/dictionary-internal.h
===================================================================
--- libfdproto/dictionary-internal.h	(revision 1451)
+++ libfdproto/dictionary-internal.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/dictionary.c
===================================================================
--- libfdproto/dictionary.c	(revision 1451)
+++ libfdproto/dictionary.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/dictionary_functions.c
===================================================================
--- libfdproto/dictionary_functions.c	(revision 1405)
+++ libfdproto/dictionary_functions.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/fifo.c
===================================================================
--- libfdproto/fifo.c	(revision 1539)
+++ libfdproto/fifo.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/log.c
===================================================================
--- libfdproto/log.c	(revision 1407)
+++ libfdproto/log.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/messages.c
===================================================================
--- libfdproto/messages.c	(revision 1549)
+++ libfdproto/messages.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: libfdproto/sessions.c
===================================================================
--- libfdproto/sessions.c	(revision 1376)
+++ libfdproto/sessions.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testcnx.c
===================================================================
--- tests/testcnx.c	(revision 1540)
+++ tests/testcnx.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testmesg.c
===================================================================
--- tests/testmesg.c	(revision 1438)
+++ tests/testmesg.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2015, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/tests.h
===================================================================
--- tests/tests.h	(revision 1357)
+++ tests/tests.h	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2019, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *
Index: tests/testsctp.c
===================================================================
--- tests/testsctp.c	(revision 1540)
+++ tests/testsctp.c	(revision 1554)
@@ -3,5 +3,5 @@
 * Author: Sebastien Decugis <sdecugis@freediameter.net>							 *
 *													 *
-* Copyright (c) 2013, WIDE Project and NICT								 *
+* Copyright (c) 2020, WIDE Project and NICT								 *
 * All rights reserved.											 *
 * 													 *