Index: INSTALL.Fedora
===================================================================
--- INSTALL.Fedora	(revision 593)
+++ INSTALL.Fedora	(revision 612)
@@ -1,4 +1,4 @@
-### Very short install notes for Fedora (tested on Fedora 13)
-# Please refer to other INSTALL files for more detailed instructions.
+### Very short install notes for Fedora (tested on Fedora 13 and 14)
+# Please refer to other INSTALL files for more detailed instructions (e.g. extension-specific notes).
 
 
@@ -8,6 +8,16 @@
 
 Following dependencies are optional, depending on which extensions you plan to compile
-# yum install postgresql-server postgresql-devel
-# yum install mysql-server mysql-devel
+ app_acct:
+	# yum install postgresql-server postgresql-devel
+
+ app_sip:
+ app_diameap:
+	# yum install mysql-server mysql-devel
+	
+ dict_legacy_xml:
+	# yum install libxml2 libxml2-devel
+	
+ dbg_interactive:
+	# yum install swig python-devel
 
 
@@ -21,2 +31,7 @@
 # cmake ..
 # make
+
+
+There is currently no Fedora-specific package for freeDiameter.
+You are welcome to contribute packaging scripts! Please contact with
+dev@freediameter.net for more details.
Index: INSTALL.OpenSUSE
===================================================================
--- INSTALL.OpenSUSE	(revision 612)
+++ INSTALL.OpenSUSE	(revision 612)
@@ -0,0 +1,37 @@
+### Very short install notes for OpenSUSE (tested on OpenSUSE 11.3)
+# Please refer to other INSTALL files for more detailed instructions (e.g. extension-specific notes).
+
+
+Dependencies on OpenSUSE 11.3 (from minimal server system installation):
+# zypper install cmake make gcc flex bison lksctp-tools-devel libgnutls-devel libgcrypt-devel
+# zypper install mercurial
+
+Following dependencies are optional, depending on which extensions you plan to compile
+ app_acct:
+	# zypper install postgresql-server postgresql-devel
+
+ app_sip:
+ app_diameap:
+ 	# zypper install libmysqlclient-devel 
+	(would also need a server, not sure which package is appropriate)
+	
+ dict_legacy_xml:
+	# zypper install libxml2 libxml2-devel
+	
+ dbg_interactive:
+	# zypper install swig python-devel
+
+
+Fetching the latest source:
+# hg clone http://www.freediameter.net/hg/freeDiameter
+# cd freeDiameter
+
+Compiling in a separate directory:
+# mkdir test.build
+# cd test.build
+# cmake ..
+# make
+
+There is currently no OpenSUSE-specific package for freeDiameter.
+You are welcome to contribute packaging scripts! Please contact with
+dev@freediameter.net for more details.
Index: INSTALL.Ubuntu
===================================================================
--- INSTALL.Ubuntu	(revision 600)
+++ INSTALL.Ubuntu	(revision 612)
@@ -22,8 +22,18 @@
  mercurial gdb
  
-In order to build app_acct extension, you will also need the package libpq-dev.
-In order to build app_sip or app_diameap extension, you will also need the package libmysqlclient-dev.
-In order to build dict_legacy_xml extension, you will need libxml2-dev.
+Extensions additional dependencies:
+ app_acct:
+	libpq-dev
 
+ app_sip:
+ app_diameap:
+ 	libmysqlclient-dev
+	
+ dict_legacy_xml:
+ 	libxml2-dev
+	
+ dbg_interactive:
+ 	swig python-dev
+	
 
 If your debhelper environment is recent (> 7.3.9 to provide cmake support), 
@@ -31,5 +41,6 @@
 
 # Install the dependencies for building the source:
-sudo apt-get -y install mercurial cmake make gcc bison flex libsctp-dev libgnutls-dev libgcrypt-dev libpq-dev libmysqlclient-dev libxml2-dev ssl-cert debhelper fakeroot
+sudo apt-get -y install mercurial cmake make gcc bison flex libsctp-dev libgnutls-dev libgcrypt-dev ssl-cert debhelper fakeroot \
+   libpq-dev libmysqlclient-dev libxml2-dev swig python-dev
 
 # Retrieve the latest version of the source package
Index: contrib/nightly_tests/README
===================================================================
--- contrib/nightly_tests/README	(revision 608)
+++ contrib/nightly_tests/README	(revision 612)
@@ -22,8 +22,15 @@
       # pkg_add -r -v wget
       # pkg_add -r -v `wget http://www.freediameter.net/hg/freeDiameter/raw-file/tip/contrib/nightly_tests/prereqs.freebsd -O - | grep -v -e "^#"`
+      
+  c) OpenSUSE:
+	$ sudo zypper install `wget http://www.freediameter.net/hg/freeDiameter/raw-file/tip/contrib/nightly_tests/prereqs.opensuse -O - | grep -v -e "^#"`
+  
+  d) Fedora:
+	$ sudo yum install `wget http://www.freediameter.net/hg/freeDiameter/raw-file/tip/contrib/nightly_tests/prereqs.fedora -O - | grep -v -e "^#"`
+        
 
 2) Create the "test" database for app_acct test (we assume the tests are run as user "test" here)
       - check INSTALL.FreeBSD file for specific PostgreSQL pre-install instructions.
-      - These are the instructions for Debian/Ubuntu, adjust as needed:
+      - These are the instructions for Debian/Ubuntu/OpenSUSE,  adjust as needed:
 	# su - postgres
 	# createuser test
@@ -50,4 +57,5 @@
 	 "Route-Record4" bytea );
 	 \q
+	 
 
 3) Create a directory ~/fDtests
@@ -66,5 +74,5 @@
    	$ echo "set(CTEST_BUILD_OPTIONS \"\${CTEST_BUILD_OPTIONS} -DFLEX_EXECUTABLE:FILEPATH=/usr/local/bin/flex\")" >> local.cmake
 	
-6) Run the runscript.sh script once to check it works properly (freeBSD might require: ln -s /usr/local/bin/bash /bin/bash)
+6) Run the runtests.sh script once to check it works properly (freeBSD might require: ln -s /usr/local/bin/bash /bin/bash)
 
 7) Set up a crontab to run the script
Index: contrib/nightly_tests/prereqs.fedora
===================================================================
--- contrib/nightly_tests/prereqs.fedora	(revision 612)
+++ contrib/nightly_tests/prereqs.fedora	(revision 612)
@@ -0,0 +1,6 @@
+# Fedora packages names of dependencies for nightly tests (using "yum install <packages>"):
+cmake make gcc flex bison lksctp-tools-devel gnutls-devel libgcrypt-devel mercurial
+postgresql-server postgresql-devel
+mysql-server mysql-devel
+libxml2 libxml2-devel
+swig python-devel
Index: contrib/nightly_tests/prereqs.freebsd
===================================================================
--- contrib/nightly_tests/prereqs.freebsd	(revision 608)
+++ contrib/nightly_tests/prereqs.freebsd	(revision 612)
@@ -2,3 +2,4 @@
 # 2: install wget with command: pkg_add -r -v wget
 # Finally, install the other packages from this file
-bash cmake mercurial flex bison gnutls postgresql84-client postgresql84-server mysql50-client libxml2
+# pkg_add -r -v `wget http://www.freediameter.net/hg/freeDiameter/raw-file/tip/contrib/nightly_tests/prereqs.freebsd -O - | grep -v -e "^#"``
+bash cmake mercurial flex bison gnutls postgresql84-client postgresql84-server mysql50-client libxml2 swig
Index: contrib/nightly_tests/prereqs.opensuse
===================================================================
--- contrib/nightly_tests/prereqs.opensuse	(revision 612)
+++ contrib/nightly_tests/prereqs.opensuse	(revision 612)
@@ -0,0 +1,7 @@
+# OpenSUSE packages names of dependencies for nightly tests (using "zypper install <packages>"):
+# zypper install `wget http://www.freediameter.net/hg/freeDiameter/raw-file/tip/contrib/nightly_tests/prereqs.opensuse -O - | grep -v -e "^#"`
+cmake mercurial make gcc flex bison lksctp-tools-devel libgnutls-devel libgcrypt-devel
+postgresql-server postgresql-devel libmysqlclient-devel libxml2-devel swig python-devel
+
+# Afterwards, you may need to issue the following command so that postgresql starts at boot: 
+#  insserv postgresql
Index: contrib/nightly_tests/prereqs.ubuntu
===================================================================
--- contrib/nightly_tests/prereqs.ubuntu	(revision 608)
+++ contrib/nightly_tests/prereqs.ubuntu	(revision 612)
@@ -1,3 +1,3 @@
 # Packages (Ubuntu names)
-cmake mercurial make gcc flex bison binutils libsctp-dev libgnutls-dev valgrind wget libpq-dev postgresql libmysqlclient-dev libxml2-dev libxml2
+cmake mercurial make gcc flex bison binutils libsctp-dev libgnutls-dev valgrind wget libpq-dev postgresql libmysqlclient-dev libxml2-dev libxml2 swig python-dev 
 