Index: include/freeDiameter/libfreeDiameter.h
===================================================================
--- include/freeDiameter/libfreeDiameter.h	(revision 620)
+++ include/freeDiameter/libfreeDiameter.h	(revision 621)
@@ -81,6 +81,4 @@
 /*                          INIT                              */
 /*============================================================*/
-#ifndef SWIG  /* This section is not included in wrapper */
-
 
 /* This function must be called first, before any call to another library function */
@@ -93,5 +91,4 @@
 
 
-#endif /* !SWIG */
 /*============================================================*/
 /*                          DEBUG                             */
@@ -118,7 +115,5 @@
  */
 void fd_log_debug ( char * format, ... );
-#ifndef SWIG
 extern pthread_mutex_t	fd_log_lock;
-#endif /* !SWIG */
 extern char * fd_debug_one_function;
 extern char * fd_debug_one_file;
@@ -139,8 +134,6 @@
  *  None.
  */
-#ifndef SWIG 
 void fd_log_threadname ( char * name );
 extern pthread_key_t	fd_log_thname;
-#endif /* !SWIG */
 
 /*
@@ -165,9 +158,7 @@
 /*============================================================*/
 
-#ifndef SWIG 
 #ifndef ASSERT
 #define ASSERT(x) assert(x)
 #endif /* ASSERT */
-#endif /* !SWIG */
 
 /* levels definitions */
@@ -180,14 +171,10 @@
 
 /* Default level is INFO */
-#ifndef SWIG 
 #ifndef TRACE_LEVEL 
 #define TRACE_LEVEL INFO
 #endif /* TRACE_LEVEL */
-#endif /* !SWIG */
 
 /* The level of the file being compiled. */
-#ifndef SWIG 
 static int local_debug_level = TRACE_LEVEL;
-#endif /* !SWIG */
 
 /* A global level, changed by configuration or cmd line for example. default is 0. */
@@ -195,5 +182,4 @@
 
 /* Some portability code to get nice function name in __PRETTY_FUNCTION__ */
-#ifndef SWIG 
 #if __STDC_VERSION__ < 199901L
 # if __GNUC__ >= 2
@@ -206,15 +192,11 @@
 #define __PRETTY_FUNCTION__ __func__
 #endif /* __PRETTY_FUNCTION__ */
-#endif /* !SWIG */
 
 /* A version of __FILE__ without the full path */
-#ifndef SWIG 
 static char * file_bname = NULL;
 #define __STRIPPED_FILE__	(file_bname ?: (file_bname = basename(__FILE__)))
-#endif /* !SWIG */
 
 
 /* Boolean for tracing at a certain level */
-#ifndef SWIG 
 #ifdef DEBUG
 #define TRACE_BOOL(_level_) ( ((_level_) <= local_debug_level + fd_g_debug_lvl) 					\
@@ -224,5 +206,4 @@
 #define TRACE_BOOL(_level_) ((_level_) <= local_debug_level + fd_g_debug_lvl)
 #endif /* DEBUG */
-#endif /* !SWIG */
 
 
@@ -230,5 +211,4 @@
  The general debug macro, each call results in two lines of debug messages (change the macro for more compact output) 
  *************/
-#ifndef SWIG 
 #ifdef DEBUG
 /* In DEBUG mode, we add (a lot of) meta-information along each trace. This makes multi-threading problems easier to debug. */
@@ -260,10 +240,8 @@
 }
 #endif /* DEBUG */
-#endif /* !SWIG */
 
 /*************
  Derivatives from this macro 
  ************/
-#ifndef SWIG 
 /* Helper for function entry -- for very detailed trace of the execution */
 #define TRACE_ENTRY(_format,_args... ) \
@@ -397,5 +375,4 @@
 #endif /* STRIP_DEBUG_CODE */
 
-#endif /* !SWIG */
 
 /*============================================================*/
@@ -406,5 +383,4 @@
  * These macro should be used only when errors are improbable, not for expected errors.
  */
-#ifndef SWIG 
 
 /* Check the return value of a system function and execute fallback in case of error */
@@ -500,5 +476,4 @@
 }
 
-#endif /* !SWIG */
 
 
@@ -507,5 +482,4 @@
 /*============================================================*/
 
-#ifndef SWIG 
 
 /* helper macros (pre-processor hacks to allow macro arguments) */
@@ -591,5 +565,4 @@
 #endif /* BUFSIZ */
 
-#endif /* !SWIG */
 
 
@@ -597,5 +570,4 @@
 /*                          THREADS                           */
 /*============================================================*/
-#ifndef SWIG 
 
 /* Terminate a thread */
@@ -660,5 +632,4 @@
 	}
 }
-#endif /* !SWIG */
 
 /*============================================================*/
@@ -669,7 +640,5 @@
 /* EALREADY will be returned if there is already a callback registered on this signal */
 /* NOTE: the signal handler will be called from a new detached thread */
-#ifndef SWIG 
 int fd_sig_register(int signal, char * modname, void (*callback)(int signal));
-#endif /* !SWIG */
 
 /* Remove the handler for a given signal */
@@ -1582,7 +1551,5 @@
 
 /* The following function must be called to activate the session expiry mechanism */
-#ifndef SWIG 
 int fd_sess_start(void);
-#endif /* !SWIG */
 
 /*
@@ -2172,8 +2139,6 @@
  *  EINVAL: a parameter is invalid
  */
-#ifndef SWIG
 int fd_msg_anscb_associate( struct msg * msg, void ( *anscb)(void *, struct msg **), void  * data );
 int fd_msg_anscb_get      ( struct msg * msg, void (**anscb)(void *, struct msg **), void ** data );
-#endif /* !SWIG */
 
 /*
@@ -2192,7 +2157,5 @@
  *  EINVAL: a parameter is invalid
  */
-#ifndef SWIG
 int fd_msg_rt_associate( struct msg * msg, struct rt_data ** rtd );
-#endif /* !SWIG */
 int fd_msg_rt_get      ( struct msg * msg, struct rt_data ** rtd );
 
@@ -2232,7 +2195,5 @@
  *  !0      	: an error occurred.
  */
-#ifndef SWIG
 int fd_msg_source_set( struct msg * msg, char * diamid, int add_rr, struct dictionary * dict );
-#endif /* !SWIG */
 int fd_msg_source_get( struct msg * msg, char ** diamid );
 
@@ -2310,7 +2271,5 @@
  *  ENOTSUP 	: There is no appropriate callback registered with this AVP's type.
  */
-#ifndef SWIG
 int fd_msg_avp_value_encode ( void *data, struct avp *avp );
-#endif /* !SWIG */
 /*
  * FUNCTION:	fd_msg_avp_value_interpret
@@ -2330,7 +2289,5 @@
  *  ENOTSUP 	: There is no appropriate callback registered with this AVP's type.
  */
-#ifndef SWIG
 int fd_msg_avp_value_interpret ( struct avp *avp, void *data );
-#endif /* !SWIG */
 
 